%%
function [chan_fr,IQ_signal]=Transmitter(mes,msg_leng1,v_mod1,mPos1,SNR1)
%clear;
%clc;
global pilotIndexes;
global Nc;
%  :
data_l2=mes;
msg_l=msg_leng1;
v_mod=v_mod1;
mPos=mPos1;
SNR=SNR1;
%       OFDM-, 
%   msg_length .  OFDM- Nc=32, 4
%     , 5   
%=======================================================================%
%% 
Ngr = 0; %         
%     OFDM-
pilotIndexes = [1 2 8 9 16 23 24 30 31 32];
% OFDM-
Nc=32;
%=======================================================================%
% 
trellis = poly2trellis(7,[171 133]);
data = convenc(data_l2,trellis);
%     
msg_lenght=msg_l*2;
%    
Ndata = Nc-length(pilotIndexes); % 22    
%  ,    OFDM-
s_length = Ndata * log2(mPos); % 44    QPSK
ns = floor(msg_lenght/s_length)+1; %   OFDM-
%      -    
%  ,     OFDM-,  
%      
fil_zero = zeros(1, ns*s_length - msg_lenght);

%   
if v_mod==1 %PSK
   h = modem.pskmod(mPos);
   h.inputtype = 'bit';
   h.SymbolOrder = 'gray';
   h.PhaseOffset = pi/4;
elseif v_mod==2 %QAM
   h = modem.qammod(mPos);
   h.inputtype = 'bit';
   h.SymbolOrder = 'gray';
   h.PhaseOffset = 0;
end   
 %       ,  
 %     OFDM-.
 %    .     , 
 %  ""  .
 data = [data fil_zero]';
   
 % 
 IQ_signal = modulate(h, data);
 
 % OFDM- 
 ofdmFrame = makeOfdmFrame(IQ_signal, ns);
 
 %  
 %    802.11 ( tx_gen_preamble
 %  ) 
 %  -    (  )
 ShortTrainingSymbols = sqrt(13/6)*[0 0 1+j 0 0 0 -1-j 0 0 0 1+j 0 0 0 -1-j 0 0 0 -1-j 0 0 0 1+j 0 0 0 0 0 0 -1-j 0 0 0 -1-j 0 0 0 ...
      1+j 0 0 0 1+j 0 0 0 1+j 0 0 0 1+j 0 0];

 short_symbols = ifft(ShortTrainingSymbols);
 %   16 
 Strs = short_symbols(1:16);
 %  10       
 short_trs=[Strs Strs Strs Strs Strs Strs Strs Strs Strs Strs];
 
 %  
 LongTrainingSymbols=[0 0 0 0 0 0 1 1 -1 -1 1 1 -1 1 -1 1 1 1 1 1 1 -1 -1 1 1 -1 1 -1 1 1 1 1 ...
      1 -1 -1 1 1 -1 1 -1 1 -1 -1 -1 -1 -1 1 1 -1 -1 1 -1 1 -1 1 1 1 1 0 0 0 0 0 0];
 long_symbol = ifft(LongTrainingSymbols);
 long_trs = [long_symbol(32-2*16+1:32) long_symbol long_symbol];

 
 %   (   OFDM-)
phy_frame = [short_trs long_trs ofdmFrame];
% figure(2);
% plot(abs(phy_frame)), title(' OFDM ');
%  .
%chan_fr=phy_frame;
chan_fr=awgn(phy_frame,SNR,'measured');
end
