function ofdmFrame = makeOfdmFrame(dataMod, Numfdm)

global pilotIndexes;
global Nc;

%      (
%,  ),   - BPSK
seqBarker = [-1 -1 -1 1 1 1 -1 1 1 -1 1]*4/3;
ofdmSymbol = [];
ofdmFrame = [];
indexOfPilot = 1;
indexOfData = 1;
for i=1:Numfdm
    for j=1:Nc %  IQ-  OFDM- 
        if (j==pilotIndexes(indexOfPilot))
            ofdmSymbol(j)=seqBarker(indexOfPilot);
            indexOfPilot=indexOfPilot+1;
        else
            ofdmSymbol(j) = dataMod(indexOfData);
            indexOfData=indexOfData+1;
        end
    end 
    indexOfPilot=1;
    ofdmSymbol = ifft(ofdmSymbol);
    %  ,   OFDM-,  1/8
    %    1/4, 1/16, 1/32 
    cp = ofdmSymbol(Nc-Nc/8+1:Nc);
    %     OFDM- (32 IQ-) 
    ofdmSymbol=[cp ofdmSymbol];
    %   OFDM-   
    ofdmFrame=[ofdmFrame ofdmSymbol];
    ofdmSymbol=[];
end
end